#property copyright "George Tischenko"

extern bool Monitor=true; //      ()
int Distance=25,   //        
           MinProfit=5,   //   ,     1
           Slippage=3;
extern double LLot=0.1;

int Trade=0;
double BLot,StartPrice; 
double lots;



extern int     CountBars = 200; 
extern int     OffsetFromBar  = 20;  
               
extern string _P40 = "-- .. ADX";
extern int     K = 30;
extern double  Kstop = 0.5;
extern int     Kperiod = 150;
extern int     PerADX = 14; //14

      
       bool    flagADX, old_flagADX;
       double KanalMin,KanalMax;
       double Lot;
//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init(){
  StartPrice=Bid;
  BLot=MarketInfo(Symbol(),MODE_LOTSIZE);
  
  //signal_ADX();  
  //NormalizeDouble(KanalMax-(KanalMax-KanalMin)/2,Digits);
  //Lot=NormalizeDouble(AccountBalance()/50000,1);
  //if (Lot<0.1)Lot=0.1;
  lots = 0.1;
  Lot=0.1;
  
  if(Monitor==true) 
   {int a,y=5;
    for(a=0;a<=6;a++) 
      {string N=DoubleToStr(a,0);
      ObjectCreate(N,OBJ_LABEL,0,0,0,0,0);
      ObjectSet(N,OBJPROP_CORNER,3);
      ObjectSet(N,OBJPROP_XDISTANCE,5);
      ObjectSet(N,OBJPROP_YDISTANCE,y);
      y+=20;
      }  
    }
  return(0);
  }
int deinit()
  {
//----
  if(Monitor==true)
    { for(int a=0;a<=3;a++)
         {string N=DoubleToStr(a,0);
          ObjectDelete(N);
         } 
    }
  return(0);
  }

int signal_ADX() {
   int      i, j, result;
   double   smin, smax, SsMax, SsMin, SSP, price;
   bool     old_uptrend;
   
   for (j = CountBars - PerADX; j >= 0; j--) {
      SSP = MathCeil(Kperiod / iADX(NULL, 0, PerADX, PRICE_TYPICAL, MODE_MAIN, 1));
      SsMax = High[j]; 
      SsMin = Low[j]; 
      
      for (i = j; i <= j + SSP - 1; i++) { 
         price = High[i];
         if (SsMax < price)    SsMax = price;
         price = Low[i];
         if (SsMin >= price)   SsMin = price;
      }
      smin = SsMin + (SsMax - SsMin)*K / 100; 
      smax = SsMax - (SsMax - SsMin)*K / 100; 
//  ,  
      if (Close[j] < smin) {flagADX = false; KanalMin = smin;}
//  ,  
      if (Close[j] > smax) {flagADX = true; KanalMax=smax;}
      
      result = 0;
      
      if (flagADX != old_uptrend && flagADX == true)  result = +1;  //  :  BUY,   SELL
      if (flagADX != old_uptrend && flagADX == false) result = -1;  //  :   SELL,  BUY
      
      old_uptrend = flagADX;
   }
   Distance = MathAbs(NormalizeDouble((KanalMax-KanalMin)/Point,0));
   return(result);
}

int start(){
  int i;
  signal_ADX();
  if(OrdersTotal()==0)
    {
    RefreshRates();
    if(signal_ADX()>0 && Distance<70) 
      {StartPrice = Bid;
      OrderSend(Symbol(),OP_BUY,CorrectLots(Lot),Ask,Slippage,0,0,"",1307,0,Blue);
      }
     if(signal_ADX()<0 && Distance<70)
      {StartPrice = Bid;
      OrderSend(Symbol(),OP_SELL,CorrectLots(Lot),Bid,Slippage,0,0,"",1307,0,Red);
      }
    }
  else //OrdersTotal()>0
    {//   ,       
    lots=0;
    double Type=-1, OpenPrice=0;
    for(i=0;i<OrdersTotal();i++)
      {//      
      if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES)==true)
        {
        if(OrderSymbol()==Symbol())
          {
          if(lots<OrderLots())
            {
            lots=OrderLots();
            Type=OrderType();
            OpenPrice=OrderOpenPrice();
            }
          }
        }
      }
      
     //,    -  :
    int C=0; //   
    if(OrdersTotal()==1) //    XXX/USD
      {
      if(AccountProfit()>=BLot*Lot*Point*Distance) 
        {
        switch(Type)
          {
          case 0 : Trade=1; break;
          case 1 : Trade=-1;
          }
        C=1;
        }
      }
    else //OrdersTotal()>1
      {//   ...
      if(AccountProfit()>=BLot*Lot*Point*MinProfit)
        {
        switch(Type)
          {
          case 0 : Trade=1; break;
          case 1 : Trade=-1;
          }
        C=1;
        }
      }
    
    switch(C)
      {
      case 0 : // ...
        {
        lots*=2; //  :-(
        RefreshRates();
        switch(Type)
          {
          case 0 :
            {
            if(OpenPrice-Bid>=Point*Distance*2) 
              {if(OrderSend(Symbol(),OP_SELL,CorrectLots(lots),Bid,Slippage,0,0,"",1307,0,Red)>0) return(0);}
            break;
            }
          case 1 :
            {
            if(Ask-OpenPrice>=Point*Distance*2)
              {if(OrderSend(Symbol(),OP_BUY,CorrectLots(lots),Ask,Slippage,0,0,"",1307,0,Blue)>0) return(0);}
            }
          }
        break;
        }
      case 1 : //  
        {while(OrdersTotal()>0)
          {
          int ticket_buy=0,  //  BUY (  =0)
              ticket_sell=0; //  SELL (  =0)
          for(i=0;i<OrdersTotal();i++)
            {
            if(OrderSelect(i,SELECT_BY_POS)==true)
              {
              if(OrderSymbol()==Symbol())
                {
                switch(OrderType())
                  {
                  case 0 : ticket_buy=OrderTicket(); break;
                  case 1 : ticket_sell=OrderTicket();
                  }
                }
              }
            }
          //   :  
          bool OCB=ticket_buy>0 && ticket_sell>0;
          if(OCB) OrderCloseBy(ticket_buy,ticket_sell,White); //  
          else
            {//   
            for(i=0;i<OrdersTotal();i++) // total==0,    
              {//  
              if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES)==true)
                {
                if(OrderSymbol()==Symbol())
                  {
                  RefreshRates();
                  switch(OrderType())
                    {
                    case 0 : 
                      {
                      while(!OrderClose(OrderTicket(),OrderLots(),Bid,Slippage,White)) 
                        {
                        Sleep(1000);
                        RefreshRates();
                        } 
                      break;
                      }
                    case 1 : 
                      {
                      while(!OrderClose(OrderTicket(),OrderLots(),Ask,Slippage,White)) 
                        {
                        Sleep(1000);
                        RefreshRates();
                        } 
                      }
                    }
                  }
                }
              }
            }
          }//end while
       // signal_ADX();  
        StartPrice=Bid;//NormalizeDouble(KanalMax-(KanalMax-KanalMin)/2,Digits);
        //Lot=NormalizeDouble(AccountBalance()/60000,1);
        //if (Lot<0.1)Lot=0.1;
        Lot=0.1;
        lots = 0.1;
        }
      }
    } 
//====  
  if(Monitor==true)
    {
    string str="Balance: "+DoubleToStr(AccountBalance(),2)+" $";
    ObjectSetText("0",str,10,"Arial Black",White);
    
    str="Profit: "+DoubleToStr(AccountProfit(),2)+" $";
    ObjectSetText("1",str,10,"Arial Black",Silver);
    
    str="Free Margine: "+DoubleToStr(AccountFreeMargin(),2)+" $";
    ObjectSetText("2",str,10,"Arial Black",Yellow);
    
    str="OrdersTotal: "+DoubleToStr(OrdersTotal(),0);
    ObjectSetText("3",str,10,"Arial Black",Aqua);
    
    str=" =  "+DoubleToStr(Distance,0);
    ObjectSetText("4",str,10,"Arial Black",Aqua);

    str="StartPrice =  "+DoubleToStr(StartPrice,Digits);
    ObjectSetText("5",str,10,"Arial Black",Aqua);
    
    str="lots = "+DoubleToStr(lots,2)+" / Lot = "+DoubleToStr(Lot,2);
    ObjectSetText("6",str,10,"Arial Black",Aqua);

    }
//----
  return(0);
  }
//+------------------------------------------------------------------+
//
// ==========================================================================
// ------------        ---------
//       ,    
// ==========================================================================

double CorrectLots(double lt)
{
   double ltcorr;
   double pnt =      MarketInfo(Symbol(),MODE_POINT);
   double mspr =     MarketInfo(Symbol(),MODE_SPREAD);
   double dig =      MarketInfo(Symbol(),MODE_DIGITS);
   double MaxLot =   MarketInfo(Symbol(),MODE_MAXLOT);
   double MinLot =   MarketInfo(Symbol(),MODE_MINLOT);
   double StpLot =   MarketInfo(Symbol(),MODE_LOTSTEP);
   double OneLot =   MarketInfo(Symbol(),MODE_MARGINREQUIRED);
   double TradeMrg = NormalizeDouble(AccountFreeMargin()/4.0,dig);    //  ,   
   
   lt=MathAbs(lt);
   ltcorr=lt;                       //    ltcorr   lt
   
   if (lt>=MaxLot) ltcorr=MaxLot;   //    ...
   if (lt<=MinLot) ltcorr=MinLot;   // ...  
   
   double Money=lt*OneLot+mspr*pnt;    //    

   if (Money<TradeMrg)              //    ,    - 
      {
         return(ltcorr);                                                            // ...   
      }
   else if (Money>=TradeMrg)        //      ,    ,  ...
      {
         ltcorr=MathAbs(MathFloor(TradeMrg/OneLot/StpLot)*StpLot);               // ...   
         double MoneyCorr=ltcorr*OneLot+mspr*pnt;                      
         Print("Func CorrectLots:  ",lt,"   ",ltcorr,
               "     = ",Money,
               "     = ",MoneyCorr
               ); 
         return(ltcorr);                                                         // ...    
      }
   Print("Func CorrectLots:    ");
   return(ltcorr);

   return(lt);                            //        
}
//

